package com.ejie.ab39a.control;

import com.ejie.ab39a.service.LocalidadService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.Localidad;

/**
 * LocalidadController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/localidad")

public class LocalidadController {

	private static final Logger logger = LoggerFactory.getLogger(LocalidadController.class);

	@Autowired
	private LocalidadService localidadService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idLocalidad
	 *            String id localidad
	 * @param idProvincia
	 *            String id provincia
	 * @param idMunicipio
	 *            String id municipio
	 * @param descOf
	 *            String descripcion
	 * @return Localidad Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "{idLocalidad}/{idMunicipio}/{idProvincia}/{descOf}", method = RequestMethod.GET)
	public @ResponseBody Localidad get(@PathVariable String idLocalidad, @PathVariable String idMunicipio,
			@PathVariable String idProvincia, @PathVariable String descOf) {
		Localidad localidad = new Localidad();
		localidad.setIdLocalidad(idLocalidad);
		localidad.setIdMunicipio(idMunicipio);
		localidad.setIdProvincia(idProvincia);
		localidad.setDescOf(descOf);
		localidad = this.localidadService.find(localidad);
		LocalidadController.logger.info("[GET - findBy_PK] : Obtener Localidad por PK");
		return localidad;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterLocalidad
	 *            Localidad Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @param codTH
	 *            String codigo territorio historico
	 * @param codmun
	 *            String codigo municipio
	 * @return List<Localidad> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(value = "getAllLocalidad", method = RequestMethod.GET)
	public @ResponseBody List<Localidad> getAll(@ModelAttribute Localidad filterLocalidad,
			@RequestParam(value = "codth", required = false) String codTH,
			@RequestParam(value = "codmun", required = false) String codmun) {
		LocalidadController.logger.info("[GET - find_ALL] : Obtener Localidad por filtro");
		filterLocalidad.setIdProvincia(codTH);
		filterLocalidad.setIdMunicipio(codmun);
		return this.localidadService.findAll(filterLocalidad, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param localidad
	 *            Localidad Bean que contiene la informacion a modificar.
	 * @return Localidad Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Localidad edit(@RequestBody Localidad localidad) {
		Localidad localidadAux = this.localidadService.update(localidad);
		LocalidadController.logger.info("[PUT] : Localidad actualizado correctamente");
		return localidadAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param localidad
	 *            Localidad Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Localidad Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Localidad add(@RequestBody Localidad localidad) {
		Localidad localidadAux = this.localidadService.add(localidad);
		LocalidadController.logger.info("[POST] : Localidad insertado correctamente");
		return localidadAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idLocalidad
	 *            String id localidad
	 * @param idProvincia
	 *            String id provincia
	 * @param idMunicipio
	 *            String id muni
	 * @param descOf
	 *            String Identificador del objeto que se desea eliminar.
	 * @return Localidad Bean eliminado.
	 */
	@RequestMapping(value = "/{idLocalidad}/{idMunicipio}/{idProvincia}/{descOf}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Localidad remove(@PathVariable String idLocalidad, @PathVariable String idMunicipio,
			@PathVariable String idProvincia, @PathVariable String descOf) {
		Localidad localidad = new Localidad();
		localidad.setIdLocalidad(idLocalidad);
		localidad.setIdProvincia(idProvincia);
		localidad.setIdMunicipio(idMunicipio);
		localidad.setDescOf(descOf);
		this.localidadService.remove(localidad);
		LocalidadController.logger.info("[DELETE] : Localidad borrado correctamente");
		return localidad;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		LocalidadController.logger.info("[GET - View] : localidad");
		return "localidad";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterLocalidad
	 *            Localidad Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Localidad> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Localidad> filter(
			@RequestJsonBody(param = "filter") Localidad filterLocalidad,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		LocalidadController.logger.info("[POST - filter] : Obtener Localidads");
		return this.localidadService.filter(filterLocalidad, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterLocalidad
	 *            Localidad Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Localidad filterLocalidad,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		LocalidadController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Localidads");
		this.localidadService.removeMultiple(filterLocalidad, jqGridRequestDto, false);
		LocalidadController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
